// Add the import library dll.lib file to the linker after building Dll.dll for Load-Time Dynamic Linking. 
// Project->Project options->Linker->Library and object files: kernel32.lib... dll.lib 
#include <windows.h>
#include <tchar.h>
#include "DllTester.h"

#define MAIN_WINDOW_WIDTH  768
#define MAIN_WINDOW_HEIGHT 512


LRESULT CALLBACK MainWndProc( HWND, UINT, WPARAM, LPARAM);

typedef void ( *DLLMESSAGE)( HWND);                                                       // Define an identifier for the .dll function
void WINAPI DllMessageBoxLoadTime( HWND);                                                 // Define a function prototype for the .dll function 


int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpszCmdLine, int nCmdShow)
 {
  WNDCLASSEX wc;
  HWND hwnd;
  MSG uMsg;
  int xPos, yPos; 

     wc.cbSize = sizeof (WNDCLASSEX);
     wc.lpszClassName = _T( "DllTester");
     wc.lpfnWndProc = MainWndProc;
     wc.style = CS_VREDRAW | CS_HREDRAW;
     wc.hInstance = hInstance;
     wc.hIcon = LoadIcon( hInstance, IDI_APPLICATION);
     wc.hIconSm = wc.hIcon;
     wc.hCursor = LoadCursor( NULL, IDC_ARROW);
     wc.hbrBackground = ( HBRUSH)( COLOR_WINDOW + 1);
     wc.lpszMenuName = "DllTesterMenu";
     wc.cbClsExtra = 0;
     wc.cbWndExtra = 0;

    if(!RegisterClassEx( &wc))
       return 1;

     xPos = GetSystemMetrics(SM_CXSCREEN);
     xPos = ( xPos - MAIN_WINDOW_WIDTH) >> 1;                                             // or ( xPos - MAIN_WINDOW_WIDTH) / 2;
                                                                                          // Compute central position for the main window  
     yPos = GetSystemMetrics(SM_CYSCREEN);
     yPos = ( yPos - MAIN_WINDOW_HEIGHT) >> 1; 

     hwnd = CreateWindowEx( 0,_T("DllTester"), _T("Dll tester example"),
                        WS_OVERLAPPEDWINDOW, xPos,yPos,
                        MAIN_WINDOW_WIDTH, MAIN_WINDOW_HEIGHT, NULL, NULL,
                        hInstance, NULL);
    if(!hwnd)
        return 1;

     ShowWindow( hwnd, SW_SHOWNORMAL);
     UpdateWindow( hwnd);

    while (GetMessage( &uMsg, NULL, 0, 0))
      {
        TranslateMessage( &uMsg);
        DispatchMessage( &uMsg);
       }

    return uMsg.wParam;
 }

LRESULT CALLBACK MainWndProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
 {
  HINSTANCE hinstLib;
  DLLMESSAGE DllMessage;

   switch(uMsg) 
    { 
      case WM_CREATE:

      return 0;  

      case WM_COMMAND:
         if(HIWORD(wParam) == 0)                                                          // Process menu messages 
          {
           switch(LOWORD(wParam))
		    {
             case IDM_LOAD_TIME_DYNAMIC_LINKING:
              DllMessageBoxLoadTime( hwnd);                                               // Call .dll function that was
             break;                                                                       // linked with the import library Dll.lib

             case IDM_RUN_TIME_DYNAMIC_LINKING:
              hinstLib = LoadLibrary("Dll.dll");                                          // Load the Dll.dll

              DllMessage = (DLLMESSAGE)GetProcAddress( hinstLib, "DllMessageBoxRunTime"); // Get the address of the DllMessageBox function   

              DllMessage( hwnd);                                                          // Call the DllMessageBox function  

              FreeLibrary( hinstLib);                                                     // Unload the Dll.dll 
             break; 

             case IDM_EXIT:
                 DestroyWindow( hwnd);  
             break;
             }
           }  
      return 0;

      case WM_DESTROY: 
          PostQuitMessage( 0);
      return 0; 
     } 

    return DefWindowProc(hwnd, uMsg, wParam, lParam); 
 }
